<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeatColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeatColumn
 * @subpackage Arrays
 */
class ArrayOfSeatColumn extends AbstractStructArrayBase
{
    /**
     * The SeatColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\SeatColumn[]
     */
    public $SeatColumn;
    /**
     * Constructor method for ArrayOfSeatColumn
     * @uses ArrayOfSeatColumn::setSeatColumn()
     * @param \App|C\StructType\SeatColumn[] $seatColumn
     */
    public function __construct(array $seatColumn = array())
    {
        $this
            ->setSeatColumn($seatColumn);
    }
    /**
     * Get SeatColumn value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\SeatColumn[]|null
     */
    public function getSeatColumn()
    {
        return isset($this->SeatColumn) ? $this->SeatColumn : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatColumnForArrayConstraintsFromSetSeatColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSeatColumnSeatColumnItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeatColumnSeatColumnItem instanceof \App|C\StructType\SeatColumn) {
                $invalidValues[] = is_object($arrayOfSeatColumnSeatColumnItem) ? get_class($arrayOfSeatColumnSeatColumnItem) : sprintf('%s(%s)', gettype($arrayOfSeatColumnSeatColumnItem), var_export($arrayOfSeatColumnSeatColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatColumn property can only contain items of type \App|C\StructType\SeatColumn, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatColumn value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\SeatColumn[] $seatColumn
     * @return \App|C\ArrayType\ArrayOfSeatColumn
     */
    public function setSeatColumn(array $seatColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($seatColumnArrayErrorMessage = self::validateSeatColumnForArrayConstraintsFromSetSeatColumn($seatColumn))) {
            throw new \InvalidArgumentException($seatColumnArrayErrorMessage, __LINE__);
        }
        if (is_null($seatColumn) || (is_array($seatColumn) && empty($seatColumn))) {
            unset($this->SeatColumn);
        } else {
            $this->SeatColumn = $seatColumn;
        }
        return $this;
    }
    /**
     * Add item to SeatColumn value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\SeatColumn $item
     * @return \App|C\ArrayType\ArrayOfSeatColumn
     */
    public function addToSeatColumn(\App|C\StructType\SeatColumn $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\SeatColumn) {
            throw new \InvalidArgumentException(sprintf('The SeatColumn property can only contain items of type \App|C\StructType\SeatColumn, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\SeatColumn|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\SeatColumn|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\SeatColumn|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\SeatColumn|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\SeatColumn|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatColumn
     */
    public function getAttributeName()
    {
        return 'SeatColumn';
    }
}
